"use strict";

exports.__esModule = true;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _firstComponent = require("../../src/styles/first-component.css");

var _firstComponent2 = _interopRequireDefault(_firstComponent);

var _renderFriend = require("./render-friend");

var _renderFriend2 = _interopRequireDefault(_renderFriend);

var _guestList = require("./guest-list");

var _guestList2 = _interopRequireDefault(_guestList);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FirstComponent = function (_Component) {
	(0, _inherits3.default)(FirstComponent, _Component);

	function FirstComponent(props) {
		(0, _classCallCheck3.default)(this, FirstComponent);
		return (0, _possibleConstructorReturn3.default)(this, _Component.call(this, props));
	}

	FirstComponent.prototype.renderFriends = function renderFriends(friends, party) {
		var invitees = this.props.invitees;
		var partyTime = party ? _firstComponent2.default.party : "";

		return friends.filter(function (friend) {
			return !!invitees.filter(function (invitee) {
				return invitee.name === friend.name && invitee.invited;
			}).length;
		}).map(function (friend) {
			return _react2.default.createElement(_renderFriend2.default, { className: partyTime, key: friend.name, friend: friend });
		});
	};

	FirstComponent.prototype.viewState = function viewState(view) {
		if (view) {
			return view;
		}
		return {
			intro: true,
			invite: true
		};
	};

	FirstComponent.prototype.houseParty = function houseParty(invitees, party) {
		return party ? _firstComponent2.default.FirstComponent + " " + _firstComponent2.default.house : _firstComponent2.default.house;
	};

	FirstComponent.prototype.render = function render() {
		var _props = this.props,
		    ourFriends = _props.ourFriends,
		    invitees = _props.invitees,
		    view = _props.view,
		    message = _props.message,
		    _toggleGuest = _props.toggleGuest;

		var party = invitees.length === invitees.filter(function (invitee) {
			return invitee.invited;
		}).length && invitees.length > 0;

		var _viewState = this.viewState(view),
		    invite = _viewState.invite,
		    intro = _viewState.intro;

		var houseParty = this.houseParty(invitees, party);

		return _react2.default.createElement(
			"div",
			null,
			invite && invitees.length > 0 && _react2.default.createElement(_guestList2.default, { invitees: invitees, toggleGuest: function toggleGuest(invitee) {
					return _toggleGuest(invitee);
				} }),
			_react2.default.createElement(
				"div",
				{ className: _firstComponent2.default.container },
				intro && !invitees.filter(function (invitee) {
					return invitee.invited;
				}).length && message(_firstComponent2.default.message),
				_react2.default.createElement(
					"div",
					{ className: houseParty },
					_react2.default.createElement(
						"div",
						{ className: _firstComponent2.default.room },
						this.renderFriends(ourFriends, party)
					)
				)
			)
		);
	};

	return FirstComponent;
}(_react.Component);

exports.default = FirstComponent;


FirstComponent.displayName = "FirstComponent";

FirstComponent.propTypes = {
	ourFriends: _react.PropTypes.array,
	message: _react.PropTypes.func,
	invitees: _react.PropTypes.array,
	view: _react.PropTypes.object,
	toggleGuest: _react.PropTypes.func
};

FirstComponent.defaultProps = {
	ourFriends: [],
	message: function message() {
		return "<p>Let's party! Un-comment the all the commented-out lines in the\n      playground then check the boxes on the GuestList to invite our friends to the party!</p>";
	},
	invitees: []
};